module.exports = {
  sourceType: 'unambiguous',
  presets: [
    '@babel/preset-react',
    [
      '@babel/env',
      {
        useBuiltIns: 'usage',
        modules: false,
        shippedProposals: false,
        corejs: 3,
        targets: {
          ie: 10,
          chrome: 35,
          android: '4.4',
          safari: '7',
          ios: 9,
          node: 'current',
        },
      },
    ],
  ],

  env: {
    // Same as done with modern
    es: {
      presets: [
        '@babel/preset-react',
        [
          '@babel/env',
          {
            useBuiltIns: 'usage',
            modules: false,
            shippedProposals: false,
            corejs: 3,
            targets: [
              'edge >= 17', // Was 16, but we opt for 17 so we can avoid urlsearchparams
              'firefox >= 60',
              'chrome >= 60',
              'safari >= 11',
              'ios >= 12',
              'opera >= 60',
            ],
          },
        ],
      ],
    },

    production: {
      presets: [
        '@babel/preset-react',
        [
          '@babel/env',
          {
            useBuiltIns: 'usage',
            modules: false,
            shippedProposals: false,
            corejs: 3,
            targets: {
              ie: 10,
              chrome: 35,
              android: '4.4',
              safari: '7',
              ios: 9,
              node: 'current',
            },
          },
        ],
      ],
    },

    test: {
      presets: [
        '@babel/preset-react',
        [
          '@babel/env',
          {
            targets: {
              node: 'current',
            },
          },
        ],
      ],
    },
  },
};
