/* eslint-disable camelcase */
import fetchRPC from './index';

// Mock
fetchRPC.mock('bestprice.GetProducts', {
  products: [
    {
      ratings_avg: 3,
      ratings_count: 5,
    },
  ],
});

describe('fetchRPC with transform', () => {
  it('Should return ratings', async () => {
    const res = await fetchRPC('bestprice.GetProducts', ['2155772279'], {
      needRatings: true,
    }, {
      transform: true, // will transform needRatings to need_ratings
    });

    // First product
    const product = Object.values(res.products)[0];

    expect(product).toHaveProperty('ratingsAvg');

    expect(product).toHaveProperty('ratingsCount');
  });
});

