// https://spectrum.chat/react/help/component-with-hook-not-working-321-code~8abc292e-6b95-49a2-8d76-a5772ae2e263
import { useState, useEffect } from 'react';
import fetchRPC from './index';

export default (...args) => {
  const [response, setResponse] = useState(null);
  const [isLoading, setIsLoading] = useState(true);

  // eslint-disable-next-line
  const [error, setError] = useState(null);

  const firstArgument = args[0];

  let m;
  let a;
  let options = {};
  let deps = null;

  // Passed as argumennt
  if (typeof firstArgument === 'object') {
    m = firstArgument.m;
    a = firstArgument.a;
    options = firstArgument.options || {};

    deps = args[1];
  } else {
    m = firstArgument;
    a = args.slice(1);
  }

  if (options) {
    // TODO: Handle options here, if available
  }

  useEffect(() => {
    setError(null);
    setIsLoading(true);

    let req;

    try {
      req = Reflect.apply(fetchRPC, null, [m, ...a])
        .then(res => {
          setResponse(res);
          setIsLoading(false);
        })
        .catch(e => {
          setError(e);
          setIsLoading(false);
        });
      // We do not throw, we pass it as error
    } catch (e) {
      setError(e);
      setIsLoading(false);
    }

    return () => {
      if (req.abort) {
        req.abort();
      }
    };
    // eslint-disable-next-line
  }, deps || [m, JSON.stringify(a)]);

  return {
    response,
    isLoading,
    error,
  };
};
