/* eslint-disable camelcase */
import { transformRequest, transformResponse } from './transform';

describe('Tranform tests', () => {
  it('Should transformRequest', () => {
    expect(transformRequest({ helloWorld: true }, { transform: true })).toMatchObject({ hello_world: true });
    expect(transformRequest({ helloWorld: true }, { transformRequest: true })).toMatchObject({ hello_world: true });
    expect(transformRequest({ helloWorldThisIsBestPriceSpeaking: true }, { transform: true }))
      .toMatchObject({ hello_world_this_is_best_price_speaking: true });
    expect(transformRequest({ test: true }, { transform: true })).toMatchObject({ test: true });

    expect(transformRequest({
      filterBy: {
        test: 1,
      },
    }, { transform: true })).toMatchObject({ filter_by: { test: 1 } });
  });

  it('Should transformResponse', () => {
    expect(transformResponse({ product_id: 10 }, { transform: true })).toMatchObject({ productId: 10 });
    expect(transformResponse({ product_id: 10 }, { transformResponse: true })).toMatchObject({ productId: 10 });
    expect(transformResponse({ product_id: 10 }, { transformResponse: response => ({
      ...response,
      test: true,
    }) })).toMatchObject({ test: true }); // method
    expect(transformResponse([
      10,
      [
        {
          nested_demo_key: 2,
          nested_object: {
            deep_nested_key: 8,
          },
        },
      ],
    ], { transform: true })).toEqual([10, [{ nestedDemoKey: 2, nestedObject: { deepNestedKey: 8 } }]]);
  });
});
