import React, { useEffect } from 'react';
import fetchRPC, { useRPC } from '../src/index';

export default ({
  title: 'Tests',
});

// Mock using string
fetchRPC.mock('bestprice.StateReport', 'test');

fetchRPC.clearMocks();

// Mock using function
fetchRPC.mock(m => (m === 'bestprice.StateReport' ? 'From function' : undefined));

fetchRPC.clearMocks();

// Mock using struct
fetchRPC.mock({
  'bestprice.StateReport': 'from regexp',
});

fetchRPC.clearMocks();

// Mock using regexp
fetchRPC.mock(/StateReport/gi, 'From regexp');

// We can even mock to methods
fetchRPC.clearMocks();
fetchRPC.mock('bestprice.StateReport', args => {
  console.log(args);
  return Math.random() * 1000;
});

export const asAHook = () => {
  // eslint-disable-next-line
  const res = useRPC('bestprice.StateReport', '');
  return <p>{JSON.stringify(res)}</p>;
};

export const asHookGetProducts = () => {
  // eslint-disable-next-line
  const res = useRPC('bestprice.GetProducts', ['2155772279'], {
    needRatings: true,
  }, {
    transform: true,
  });

  return <pre>{JSON.stringify(res)}</pre>;
};

export const testError = () => {
  useEffect(() => {
    fetchRPC('qna.GetQuestion', 335, 44)
      .then(response => {
        console.log('respoonse', response);
      })
      .catch(error => {
        console.warn(error);
      });
  }, []);

  return null;
};
